//薺pY for PIC32MX370F512H with Text Graph Video Out System by K.Tanaka.

#include <plib.h>
#include "TGvideo370f.h"

extern const unsigned char *Image[10]; //摜|C^̔z
extern const unsigned int Color[10]; //摜̐Fw

//OtNX^ with PLL (20/3{)
//NX^3.579545~414.31818MHz
#pragma config FSRSSEL = PRIORITY_7
#pragma config PMDL1WAY = OFF
#pragma config IOL1WAY = OFF
//#pragma config FUSBIDIO = OFF
//#pragma config FVBUSONIO = OFF
#pragma config FPLLIDIV = DIV_3
#pragma config FPLLMUL = MUL_20
//#pragma config UPLLIDIV = DIV_1
//#pragma config UPLLEN = OFF
#pragma config FPLLODIV = DIV_1
#pragma config FNOSC = PRIPLL
#pragma config FSOSCEN = OFF
#pragma config IESO = OFF
#pragma config POSCMOD = XT
#pragma config OSCIOFNC = OFF
#pragma config FPBDIV = DIV_1
#pragma config FCKSM = CSDCMD
#pragma config FWDTEN = OFF
#pragma config DEBUG = OFF
#pragma config PWP = OFF
#pragma config BWP = OFF
#pragma config CP = OFF

// ̓{^̃|[gArbg`
#define KEYPORT PORTD
#define KEYDOWN 0x0001
#define KEYLEFT 0x0002
#define KEYUP 0x0004
#define KEYRIGHT 0x0008
#define KEYSTART 0x0010
#define KEYFIRE 0x0020

#define HAKOSIZEX 4 //̉TCY
#define HAKOSIZEY 5 //̏cTCY
#define GOALX 1 //S[XW
#define GOALY 3 //S[YW
#define BLOCKSIZEX 32 //̏chbg
#define BLOCKSIZEY 32 //̉hbg
#define BLOCKNUM 10 //

#define LEFTX 58 //\ XW
#define TOPY 25 //\ YW
#define FRAMESIZEX 7 //t[̕i㉺j
#define FRAMESIZEY 7 //t[̕iEj

#define COLOR_FRAME 12 //t[̐F
#define COLOR_BACK 13 //̐F
#define COLOR_BLOCK1 9 //̐F
#define COLOR_BLOCK2 10 //̐Fiej
#define COLOR_BLOCK3 11 //̐FinCCgj
#define COLOR_CURSOR 2 //I𒆂̋͂ސF

/*
//WtHggpɓƎtHg쐬ꍇALɂāA256̃f[^Lq
//LN^R[h8oCgAʃrbg
const unsigned char FontData[256*8]={
	0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,

};
*/

// ̏zui͋ԍj
// 󂫏ꏊ͕
const char map[HAKOSIZEY][HAKOSIZEX]={
	{1,0,0,2},
	{1,0,0,2},
	{3,4,4,5},
	{3,6,7,5},
	{8,-1,-1,9}
};

/*fobOp
const char map[HAKOSIZEY][HAKOSIZEX]={
	{3,4,4,5},
	{3,6,7,5},
	{1,0,0,2},
	{1,0,0,2},
	{8,-1,-1,9}
};
*/

//̍\̒`
typedef struct {
	int x; //xW
	int y; //yW
	int xsize; //xTCY
	int ysize; //yTCY
	const char *image; //摜ւ̃|C^
	unsigned int color; //摜̕`F
} _Block;

// O[oϐ`
_Block block[BLOCKNUM]; //̏Ԃێ
char hako[HAKOSIZEY][HAKOSIZEX]; //̔zuێ
int cursorx,cursory; //J[\Iʒu
unsigned short step; //萔
char lastblock; //Oړԍ
unsigned short keystatus,keystatus2,oldkey; //ŐṼ{^ԂƑÕ{^
int soundcount; //ړ̉o͎ԃJE^

void wait_video_end(unsigned short n){
//rfIMonI܂ł̃EFCgi60nbEFCgj
//rfIMo͊荞ݏȊO̓AChԂƂ
	drawcount=0;
	while(drawcount<n) asm("wait");
}
void keycheck(void){
//{^ԓǂݎ
//keystatus :݉Ă{^ɑΉrbg1ɂ
//keystatus2:O񉟂ĂȂāA񉟂ꂽ{^ɑΉrbg1ɂ
	oldkey=keystatus;
	keystatus=~KEYPORT & (KEYUP | KEYDOWN | KEYLEFT | KEYRIGHT | KEYSTART | KEYFIRE);
	keystatus2=keystatus & ~oldkey; //{^𗣂`FbN
}
void putblock(char d){
//ԍd̋\

	int x1,y1,x2,y2;
	int x,y,i;
	const unsigned char *p;
	unsigned char f;

	//(x1,y1)FWA(x2,y2)FEW
	x1=LEFTX+FRAMESIZEX+block[d].x*BLOCKSIZEX;
	y1=TOPY+FRAMESIZEY+block[d].y*BLOCKSIZEY;
	x2=x1+block[d].xsize*BLOCKSIZEX-1;
	y2=y1+block[d].ysize*BLOCKSIZEY-1;

	//hԂ``i㉺EɉeAnCCgtj
	boxfill(x1,y1,x2,y2,COLOR_BLOCK1);
	boxfill(x1,y2-1,x2,y2,COLOR_BLOCK3);
	boxfill(x2-1,y1,x2,y2,COLOR_BLOCK3);
	boxfill(x1,y1,x1+1,y2,COLOR_BLOCK2);
	boxfill(x1,y1,x2,y1+1,COLOR_BLOCK2);

	//̏ɉ摜ij\
	p=block[d].image;
	i=0;
	for(y=y1;y<=y2;y++){
		for(x=x1;x<=x2;x++){
			if((i&7)==0) f=*p++;
			if(f&0x80) pset(x,y,block[d].color);
			f<<=1;
			i++;
		}
	}
}
void eraseblock(char d){
//ԍd̋

	int x1,y1,x2,y2;

	//(x1,y1)FWA(x2,y2)FEW
	x1=LEFTX+FRAMESIZEX+block[d].x*BLOCKSIZEX;
	y1=TOPY+FRAMESIZEY+block[d].y*BLOCKSIZEY;
	x2=x1+block[d].xsize*BLOCKSIZEX-1;
	y2=y1+block[d].ysize*BLOCKSIZEY-1;

	//hԂ``iFj
	boxfill(x1,y1,x2,y2,COLOR_BACK);
}
void putspace(int x,int y){
//Wx,ÿʒu󔒂Ŗ߂i󔒈ʒũJ[\Ŏgpj

	int x1,y1,x2,y2;

	x1=LEFTX+FRAMESIZEX+x*BLOCKSIZEX;
	y1=TOPY+FRAMESIZEY+y*BLOCKSIZEY;
	x2=x1+BLOCKSIZEX-1;
	y2=y1+BLOCKSIZEY-1;
	boxfill(x1,y1,x2,y2,COLOR_BACK);
}
void drawcursor(void){
//J[\\
//I𒆋̎Fň͂
	char d;
	int x1,y1,x2,y2;

	d=hako[cursory][cursorx];
	if(d>=0){
		//I𒆂̏ꍇAlpň͂
		x1=LEFTX+FRAMESIZEX+block[d].x*BLOCKSIZEX;
		y1=TOPY+FRAMESIZEY+block[d].y*BLOCKSIZEY;
		x2=x1+block[d].xsize*BLOCKSIZEX-1;
		y2=y1+block[d].ysize*BLOCKSIZEY-1;
	} else {
		//󂫏ꏊI𒆂̏ꍇAŏ1̑傫̎lp\
		x1=LEFTX+FRAMESIZEX+cursorx*BLOCKSIZEX;
		y1=TOPY+FRAMESIZEY+cursory*BLOCKSIZEY;
		x2=x1+BLOCKSIZEX-1;
		y2=y1+BLOCKSIZEY-1;
	}
	//2hbg̒`\
	boxfill(x1,y1,x1+1,y2,COLOR_CURSOR);
	boxfill(x2-1,y1,x2,y2,COLOR_CURSOR);
	boxfill(x1,y1,x2,y1+1,COLOR_CURSOR);
	boxfill(x1,y2-1,x2,y2,COLOR_CURSOR);
}

void move(void){
//܂̓J[\ړ
	char d;
	int x,y,i,j;

	if(keystatus2 && (KEYUP | KEYDOWN |KEYLEFT | KEYRIGHT)==0) return;//{^ĂȂ
	d=hako[cursory][cursorx]; //J[\ꏊ̋ԍ
	if(keystatus & KEYFIRE){ //FIRE{^Ăꍇ
		//ړ̃`FbNƈړ
		if(d<0) return;//󂫏ꏊI𒆂̏ꍇ
		x=block[d].x;
		y=block[d].y;
		switch(keystatus2){
			case KEYUP: //{^̏ꍇ
				y--;
				if(y<0) return; //ԏȂ̂œȂ
				for(i=0;i<block[d].xsize;i++){
					if(hako[y][x+i]>=0) return; //オl܂Ă̂œȂ
				}
				break;
			case KEYDOWN: //{^̏ꍇ
				y+=block[d].ysize; //I𒆂̋1YW
				if(y>=HAKOSIZEY) return; //ԉȂ̂œȂ
				for(i=0;i<block[d].xsize;i++){
					if(hako[y][x+i]>=0) return; //l܂Ă̂œȂ
				}
				y=block[d].y+1;
				break;
			case KEYLEFT: //{^̏ꍇ
				x--;
				if(x<0) return; //ԍȂ̂œȂ
				for(i=0;i<block[d].ysize;i++){
					if(hako[y+i][x]>=0) return; //l܂Ă̂œȂ
				}
				break;
			case KEYRIGHT: //E{^̏ꍇ
				x+=block[d].xsize; //I𒆂̋1EXW
				if(x>=HAKOSIZEX) return; //ԉEȂ̂œȂ
				for(i=0;i<block[d].ysize;i++){
					if(hako[y+i][x]>=0) return; //El܂Ă̂œȂ
				}
				x=block[d].x+1;
				break;
			default:
				return;
		}

	//̈ړ
		//
		for(i=block[d].y;i<block[d].y+block[d].ysize;i++){
			for(j=block[d].x;j<block[d].x+block[d].xsize;j++){
				hako[i][j]=-1;
			}
		}
		eraseblock(d); //̕\
		block[d].x=x; //ړ̍WɕύX
		block[d].y=y;

		//̒gύX
		for(i=y;i<y+block[d].ysize;i++){
			for(j=x;j<x+block[d].xsize;j++){
				hako[i][j]=d;
			}
		}
		putblock(d); //\
		cursorx=x; //J[\킹Ĉړ
		cursory=y;
		drawcursor(); //J[\\
		soundcount=7; //ʉ̎Ԑݒi[v7񕪁j

		//萔XV
		//OƓړꍇ́A1̈ړƂ݂Ȃ̂ōXVȂ
		if(lastblock!=d){
			lastblock=d;
			step++;
			gprintnum2(204,192,7,0,step,6);//6̐\
		}
	}
	else{
		//J[\ړ
		x=cursorx;
		y=cursory;
		switch(keystatus2){
			case KEYUP: //{^̏ꍇ
				while(y>0){
					//1ɈړBJ[\ʒűƓꍇ͍XɏցBԏ̏ꍇ͓Ȃ
					y--;
					if(hako[y][x]!=d || hako[y][x]<0) break;
				}
				break;
			case KEYDOWN: //{^̏ꍇ
				while(y<HAKOSIZEY-1){
					//1ɈړBJ[\ʒűƓꍇ͍XɉցBԉ̏ꍇ͓Ȃ
					y++;
					if(hako[y][x]!=d || hako[y][x]<0) break;
				}
				break;
			case KEYLEFT: //{^̏ꍇ
				while(x>0){
					//1ɈړBJ[\ʒűƓꍇ͍XɍցBԍ̏ꍇ͓Ȃ
					x--;
					if(hako[y][x]!=d || hako[y][x]<0) break;
				}
				break;
			case KEYRIGHT: //E{^̏ꍇ
				while(x<HAKOSIZEX-1){
					//1EɈړJ[\ʒűƓꍇ͍XɉEցBԉȄꍇ͓Ȃ
					x++;
					if(hako[y][x]!=d || hako[y][x]<0) break;
				}
				break;
			default:
				return;
		}
		if(x==cursorx && y==cursory) return; //ړȂꍇI
		if(d>=0){ //J[\ړȌꏊ̏ꍇ
			putblock(d); //ԍd̋ĕ\iJ[\߁j
		}
		else{ //J[\ړO󂫏ꏊ̏ꍇ
			putspace(cursorx,cursory); //J[\߃Xy[X\
		}
		cursorx=x; //J[\ړ
		cursory=y;
		drawcursor(); //ړ̏ꏊɃJ[\\
	}
}
int goalcheck(void){
//pY`FbN
//߂l@:0A:1
	int i;

	if(block[0].x !=GOALX || block[0].y!=GOALY) return 0;
	//block[0]uv̋

	//̏ꍇ̏
	//~āus|s|v
	PR3=3397; //B̉炷
	wait_video_end(10); //6010b҂
	PR3=4280; //G̉炷
	wait_video_end(10); //6010b҂
	PR3=3397; //B̉炷
	wait_video_end(10); //6010b҂
	PR3=4280; //G̉炷
	wait_video_end(12); //6010b҂
	PR3=0; //~

	eraseblock(0); //uv̋̕\
	block[0].y++;
	putblock(0); //1ubNɈړĕ\
	gprintstr(64,4,7,0,"CONGRATULATIONS!"); //\

	//X^[g{^܂ŁA0.5bƂɕ\ƏJԂ
	i=0;
	while(!(keystatus2 & KEYSTART)){
		if(i==0) gprintstr(64,14,6,0,"PLAY AGAIN:START");
		else if(i==30) gprintstr(64,14,0,0,"                ");
		if(++i==60) i=0;
		wait_video_end(1);//rfIMo͏I҂i601bEFCgj
		keycheck();
	}
	return 1; //pYƂC[`ɕԂ
}

void sound(void){
//ʉo
	unsigned short pr;

	if(soundcount==0) return; //ʉȂ̎
	soundcount--;
	//ŏ603bԂ̓^C}[15000Ac603bԂ̓^C}[14000
	//`g炷
	if(soundcount==0) pr=0; //TEh~
	else if(soundcount>=4) pr=15000;
	else pr=14000;

	PR3=pr; //ۂɎύX
}
void soundstop(void){
//TEh~
	PR3=0;
}

void gameinit2(void){
//Q[X^[gɌĂ΂鏉
	int i,j;
	char d;

	clearscreen();//ʏ
	//甠̕\
	//Og`
	boxfill(LEFTX,TOPY,
		LEFTX+HAKOSIZEX*BLOCKSIZEX+FRAMESIZEX*2-1,TOPY+HAKOSIZEY*BLOCKSIZEY+FRAMESIZEY*2-1,COLOR_FRAME);
	//`
	boxfill(LEFTX+FRAMESIZEX,TOPY+FRAMESIZEY,
		LEFTX+HAKOSIZEX*BLOCKSIZEX+FRAMESIZEX-1,TOPY+HAKOSIZEY*BLOCKSIZEY+FRAMESIZEY-1,COLOR_BACK);
	//S[`
	boxfill(LEFTX+FRAMESIZEX+GOALX*BLOCKSIZEX,TOPY+HAKOSIZEY*BLOCKSIZEY+FRAMESIZEY,
		LEFTX+FRAMESIZEX+GOALX*BLOCKSIZEX+block[0].xsize*BLOCKSIZEX-1,TOPY+HAKOSIZEY*BLOCKSIZEY+FRAMESIZEY*2-1,COLOR_BACK);

	//萔\
	gprintstr(220,180,7,0,"STEP");
	gprintnum2(204,192,7,0,0,6);

	// zuɂ
	// block.x, block.y̍Wɐݒ
	for(d=0;d<BLOCKNUM;d++){
		block[d].x=-1;//SĂ蓾ȂlŃNA
	}
	for(i=0;i<HAKOSIZEY;i++){
		for(j=0;j<HAKOSIZEX;j++){
			//zuRs[
			d=map[i][j];
			hako[i][j]=d;

			//Wɐݒ
			if(d>=0 && block[d].x==-1){
				block[d].x=j;
				block[d].y=i;
			}
		}
	}
	for(d=0;d<BLOCKNUM;d++) putblock(d);//\
	step=0;//萔NA
	lastblock=BLOCKNUM;//蓾Ȃԍw
	cursorx=0;//J[\ʒuݒ
	cursory=4;
	soundcount=0;//ʉ͖ĂȂ
}

void gameinit(void){
//N1񂾂Ă΂鏉
	int i,j,k;
	char d;

	//TCYA摜̏
	for(d=0;d<BLOCKNUM;d++){
		block[d].xsize=0;//񂠂蓾ȂlŃNA
		block[d].image=Image[d];//摜ijւ̃|C^
		block[d].color=Color[d];//摜̐F
	}
	for(i=0;i<HAKOSIZEY;i++){
		for(j=0;j<HAKOSIZEX;j++){
			d=map[i][j];
			if(d>=0 && block[d].xsize==0){
				//̉TCYAcTCYTĐݒ肷
				block[d].xsize=1;
				block[d].ysize=1;
				for(k=j+1;k<HAKOSIZEX && map[i][k]==d;k++) block[d].xsize++;
				for(k=i+1;k<HAKOSIZEY && map[k][j]==d;k++) block[d].ysize++;
			}
		}
	}
	//J[pbgݒ
	//set_palette(Fԍ,B,R,G)
	set_palette(COLOR_BLOCK1,180,240,210);
	set_palette(COLOR_BLOCK2,150,200,170);
	set_palette(COLOR_BLOCK3,200,255,230);
	set_palette(COLOR_FRAME,0,255,140);
	set_palette(COLOR_BACK,120,180,130);

	//{^Ah~̏ݒ
	keystatus=KEYUP | KEYDOWN | KEYLEFT | KEYRIGHT | KEYSTART | KEYFIRE;
}
void main(void){
	/* |[g̏ݒ */
	TRISB = 0x0000;						// Sďo
	TRISC = 0x0000;						// Sďo
	TRISD = KEYSTART | KEYFIRE | KEYUP | KEYDOWN | KEYLEFT | KEYRIGHT;// {^ڑ|[g͐ݒ
	TRISE = 0x0000;						// Sďo
	TRISF = 0x0003;						// RF0,1͓
	TRISG = 0x0080;						// RG7͓
	ANSELD = 0x0000; // SăfW^
	ANSELG = 0x0000; // SăfW^
	CNPUDSET=KEYSTART | KEYFIRE | KEYUP | KEYDOWN | KEYLEFT | KEYRIGHT;// vAbvݒ

	SDI2R = 1;						//RPG7SDI2蓖
	RPG8R = 6;						//RPG8SDO2蓖

	//TEh֌Wݒ
	RPF5R = 0x0b; //RPF5OC4蓖
	OC4R=0;
	OC4CON=0x800b;// Tiemr3x[XAToggle[hŗL
	PR3=0;// Timer3
	T3CON=0x8040;// vXP[1:16Timer3Jn
	//PR3ݒ肷邾ŕ`go͂
	//TEhgf3579545~i80^3j^iPR3~16j[Hz]
	//PR3=3579545~i80^3j^if~16j

	init_composite(); // rfINAA荞ݏAJ[rfIo͊Jn

	//Q[
	gameinit();//ŏ1񂾂̏
	while(1){
		gameinit2();//Q[JnƂ̏
		drawcursor();//J[\g\

		//烁C[v
		while(1){
			wait_video_end(1);//rfIMo͏I҂i601bEFCgj
			keycheck();	//{^ǂݎ
			move();		//܂̓J[\ړ
			sound();	//ʉ炷
			if(goalcheck()) break; //pY烋[v𔲂
		}
		soundstop();	//TEh~
	}
}
